/*
 File: T_enum_phrase_th.h
 Date and Time: Fri Jan 30 18:55:26 2015 
*/
#ifndef __T_enum_phrase_th_h__
#define __T_enum_phrase_th_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "eol.h"
#include "c_comments.h"
#include "identifier.h"
#include "c_string.h"
#include "o2_sdc.h"
    using namespace NS_yacco2_terminals;
  
extern yacco2::Thread_entry ITH_T_enum_phrase_th;

extern yacco2::State S1_CT_enum_phrase_th;
namespace NS_T_enum_phrase_th {
yacco2::THR _YACCO2_CALL_TYPE
TH_T_enum_phrase_th(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_T_enum_phrase_th(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[16];
};
class CT_enum_phrase_th: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_RT_enum_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_RT_enum_phrase_ = 1
   ,R_Ropen_par_ = 570//start_of_rule_list + 2
    ,rhs1_Ropen_par_ = 2
    ,rhs2_Ropen_par_ = 3
   ,R_Rclose_par_ = 571//start_of_rule_list + 4
    ,rhs1_Rclose_par_ = 4
    ,rhs2_Rclose_par_ = 5
   ,R_Rparameters_ = 572//start_of_rule_list + 6
    ,rhs1_Rparameters_ = 6
   ,R_Rfilename_phrase_ = 573//start_of_rule_list + 8
    ,rhs1_Rfilename_phrase_ = 7
   ,R_Rfilename_ = 574//start_of_rule_list + 10
    ,rhs1_Rfilename_ = 8
    ,rhs2_Rfilename_ = 9
    ,rhs3_Rfilename_ = 10
   ,R_Rfilename_id_ = 575//start_of_rule_list + 12
    ,rhs1_Rfilename_id_ = 11
    ,rhs2_Rfilename_id_ = 12
   ,R_Rnamespace_phrase_ = 576//start_of_rule_list + 14
    ,rhs1_Rnamespace_phrase_ = 13
    ,rhs2_Rnamespace_phrase_ = 14
   ,R_Rnamespace_ = 577//start_of_rule_list + 16
    ,rhs1_Rnamespace_ = 15
    ,rhs2_Rnamespace_ = 16
    ,rhs3_Rnamespace_ = 17
   ,R_Rnamespace_id_ = 578//start_of_rule_list + 18
    ,rhs1_Rnamespace_id_ = 18
    ,rhs2_Rnamespace_id_ = 19
   ,R_Rk_defs_phrase_ = 579//start_of_rule_list + 20
    ,rhs1_Rk_defs_phrase_ = 20
   ,R_Rconstant_epi_defs_ = 580//start_of_rule_list + 22
    ,rhs1_Rconstant_epi_defs_ = 21
    ,rhs2_Rconstant_epi_defs_ = 22
   ,R_Rconstant_defs_ = 581//start_of_rule_list + 24
    ,rhs1_Rconstant_defs_ = 23
    ,rhs2_Rconstant_defs_ = 24
   ,R_Rconstant_defs_code_ = 582//start_of_rule_list + 26
    ,rhs1_Rconstant_defs_code_ = 25
    ,rhs2_Rconstant_defs_code_ = 26
    ,rhs3_Rconstant_defs_code_ = 27
   ,R_Rclose_brace_ = 583//start_of_rule_list + 28
    ,rhs1_Rclose_brace_ = 28
    ,rhs2_Rclose_brace_ = 29
   ,R_Rlint_ = 584//start_of_rule_list + 30
    ,rhs1_Rlint_ = 30
    ,rhs2_Rlint_ = 31
  };
  //no of la sets = 10
  //no of states = 58
  CT_enum_phrase_th();
  ~CT_enum_phrase_th();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[32];
  
    public:
    T_enum_phrase* enum_phrase_;
  
 };
struct RT_enum_phrase;
struct Ropen_par;
struct Rclose_par;
struct Rparameters;
struct Rfilename_phrase;
struct Rfilename;
struct Rfilename_id;
struct Rnamespace_phrase;
struct Rnamespace;
struct Rnamespace_id;
struct Rk_defs_phrase;
struct Rconstant_epi_defs;
struct Rconstant_defs;
struct Rconstant_defs_code;
struct Rclose_brace;
struct Rlint;
struct RT_enum_phrase:public yacco2::CAbs_lr1_sym {
  RT_enum_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rparameters:public yacco2::CAbs_lr1_sym {
  Rparameters(yacco2::Parser* P);
  public:
};

struct Rfilename_phrase:public yacco2::CAbs_lr1_sym {
  Rfilename_phrase(yacco2::Parser* P);
  public:
};

struct Rfilename:public yacco2::CAbs_lr1_sym {
  Rfilename(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfilename_id:public yacco2::CAbs_lr1_sym {
  Rfilename_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rnamespace_phrase:public yacco2::CAbs_lr1_sym {
  Rnamespace_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rnamespace:public yacco2::CAbs_lr1_sym {
  Rnamespace(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rnamespace_id:public yacco2::CAbs_lr1_sym {
  Rnamespace_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rk_defs_phrase:public yacco2::CAbs_lr1_sym {
  Rk_defs_phrase(yacco2::Parser* P);
  public:
};

struct Rconstant_epi_defs:public yacco2::CAbs_lr1_sym {
  Rconstant_epi_defs(yacco2::Parser* P);
  public:
};

struct Rconstant_defs:public yacco2::CAbs_lr1_sym {
  Rconstant_defs(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rconstant_defs_code:public yacco2::CAbs_lr1_sym {
  Rconstant_defs_code(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rclose_brace:public yacco2::CAbs_lr1_sym {
  Rclose_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
